#ifndef DDDISPLAY_H
#define DDDISPLAY_H

#include <ddraw.h>

class DDDisplay
{
   HWND hWnd;   // Window handle

   IDirectDraw *DirectDraw;
   IDirectDrawSurface *PrimarySurface;
   IDirectDrawSurface *BackSurface;

   HRESULT DDRVal;   // DirectDraw return value

   char *DDRValToString(HRESULT DDRVal);
   void CheckDDRVal(char *Method = "Undefined");
   void ReleaseAllObjects();

public:
   bool Active;
   bool Locked;

   unsigned long Width;
   unsigned long Height;
   unsigned long Bitdepth;

	// TODO: Make 'Buffer' class and derive BackBuffer, DepthBuffer...

   void *BackBuffer;   // Pointer to starting address of backbuffer, Lock() first!
	void *DepthBuffer;  // Pointer to starting address of z-buffer
   long Pitch;         // Physical width in bytes, use to calculate pixel position
	long Stride;        // Physical width in pixels;

   DDDisplay();

   ~DDDisplay();

   void Init(HWND, unsigned long, unsigned long, unsigned long);
   void Flip();
   void ClearDepth();              // TODO: Make DepthBuffer class with Clear() method
	void ClearBack(int fill = 0);   // TODO: Make BackBuffer class with Clear() method
   void Lock();
   void Unlock();
   void __cdecl Text(int x, int y, const char*, ...);   // Simple text output
};

extern DDDisplay Display;

#endif   // DDDISPLAY_H