#include "Point.h"

#include "Vector.h"

Point::Point() : x(Element[0]), y(Element[1]), z(Element[2])
{
}

Point::Point(const Point &P) : x(Element[0]), y(Element[1]), z(Element[2])
{
	x = P.x;
	y = P.y;
	z = P.z;
}

Point::Point(const Vector &v) : x(Element[0]), y(Element[1]), z(Element[2])
{
	x = v.x;
	y = v.y;
	z = v.z;
}

Point::Point(float P_x, float P_y, float P_z) : x(Element[0]), y(Element[1]), z(Element[2])
{
	x = P_x;
	y = P_y;
	z = P_z;
}

Point &Point::operator=(const Point &P)
{
	x = P.x;
	y = P.y;
	z = P.z;

	return *this;
}

Point &Point::operator+=(const Vector &v)
{
	x += v.x;
	y += v.y;
	z += v.z;

	return *this;
}

Point &Point::operator-=(const Vector &v)
{
	x -= v.x;
	y -= v.y;
	z -= v.z;

	return *this;
}

Point operator+(const Point &P, const Vector &v)
{
	return Point(P.x + v.x, P.y + v.y, P.z + v.z);
}

Point operator-(const Point &P, const Vector &v)
{
	return Point(P.x - v.x, P.y - v.y, P.z - v.z);
}

Vector operator-(const Point &P, const Point &Q)
{
	return Vector(P.x - Q.x, P.y - Q.y, P.z - Q.z);
}

float d(const Point &P, const Point &Q)
{
	return N(P - Q);
}

float d2(const Point &P, const Point &Q)
{
	return N2(P - Q);
}