#ifndef POINT_H
#define POINT_H

#include "Tuple.h"

class Vector;

class Point : Tuple<3>
{
public:
	float x;
	float y;
	float z;

	Point();
	Point(const Point &P);
	Point(const Vector &v);
	Point(float x, float y, float z);

	Point &operator=(const Point &P);

	Point &operator+=(const Vector &v);
	Point &operator-=(const Vector &v);

	friend Point operator+(const Point &P, const Vector &v);
	friend Point operator-(const Point &P, const Vector &v);

	friend Vector operator-(const Point &P, const Point &Q);

	friend float d(const Point &P, const Point &Q);   // Distance between two points
	friend float d2(const Point &P, const Point &Q);   // Squared distance between two points
};

#endif   // POINT_H
